#!/bin/bash
function remoteCreateSSHKey(){
	local user=$1
	local passwd=$2
	local ip=$3
        echo "create ssh in ${ip}"
	expect <<-EOF
        set timeout 3
	spawn ssh $user@$ip
	expect {
			"yes/no" { send "yes\r";exp_continue }
			"password:" {send "$passwd\r"; }
	}
	expect "#*"
	send "rm -f ~/.ssh/id_rsa\r"
	send "ssh-keygen -t rsa -P \"\" -f ~/.ssh/id_rsa > /dev/null\r"
	expect {
			"id_rsa):" { send "\r"; exp_continue }
			"Overwrite" { send "y\r"; exp_continue }
			"passphrase):" { send "\r"; exp_continue }
			"again:" { send "\r";exp_continue }
			"#*"
	}
	send "exit\r"
	expect eof
	EOF
}
#remoteCreateSSHKey "root" "huawei" "192.168.24.12"

function saveRemoteSSHKeyToLocal(){
	local user=$1
	local passwd=$2
	local ip=$3
	local localfile=$4
	expect <<-EOF
	spawn bash -c "ssh $user@$ip \"cat ~/.ssh/id_rsa.pub\" >> $localfile"
	expect {
			"yes/no" { send "yes\r";exp_continue }
			"password:" { send "$passwd\r"; exp_continue }
	}
	EOF
}
#saveRemoteSSHKeyToLocal "root" "huawei" "192.168.24.12" "~/.ssh/all_authorized_keys"

function saveLocalSSHKeyToRemote(){
	local user=$1
	local passwd=$2
	local ip=$3
	local localfile=$4
	expect <<-EOF
	spawn bash -c "scp $localfile $user@$ip:~/.ssh/"
	expect {
			"yes/no" { send "yes\r"; exp_continue }
			"password:" {send "$passwd\r"; exp_continue }
	}
	EOF
}
#saveLocalSSHKeyToRemote "root" "huawei" "192.168.24.11" "~/.ssh/all_authorized_keys"
function sshCluster(){
    local user=$1
    local passwd=$2
    local ip=$3
#    echo "ip=${ip}"
#    local masterip=$3
    local iplist=`echo ${ip} |tr ';' ' '`
    local localfile="/tmp/authorized_keys"
    rm -f $localfile
    touch ${localfile}
#    echo "$iplist"
#    echo "${ip}"
	
#    echo "$masterip is master"
#    remoteCreateSSHKey $user $passwd $masterip
#    saveRemoteSSHKeyToLocal $user $passwd $masterip $localfile
    for eachip in ${iplist[@]}
    do
        echo "ip=${eachip}"
	remoteCreateSSHKey $user $passwd $eachip
	saveRemoteSSHKeyToLocal $user $passwd $eachip $localfile
    done
	
#    saveLocalSSHKeyToRemote $user $passwd $masterip $localfile
    for eachip in ${iplist[@]}
    do
	saveLocalSSHKeyToRemote $user $passwd $eachip $localfile
    done
}
echo "begin to sshkey"
sshCluster $1 $2 $3
echo "end to sshkey"
